package w2phtml.pageSplitters;

import static w2phtml.office.XMLString.TABLE_TABLE;
import static w2phtml.office.XMLString.TEXT_H;
import static w2phtml.office.XMLString.TEXT_LIST;
import static w2phtml.office.XMLString.TEXT_P;
import static w2phtml.office.XMLString.TEXT_SOFT_PAGE_BREAK;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import w2phtml.office.OfficeReader;

public class TableCellSplitter extends BasicSplitter implements ISplitter {

	public TableCellSplitter(OfficeReader officeReader, SplitFactory factory) {
		super(officeReader, factory);
		// TODO Auto-generated constructor stub
	}

	@Override
	public boolean Split(Node cellNode) {
		Node cellFirstPart = cellNode.cloneNode(false);
		Node parent = cellNode.getParentNode();
		boolean dataMoved = false;
		// Node counter
		int i = 0;
		NodeList cellChildNodes = cellNode.getChildNodes();
		while (cellChildNodes.getLength() > i) {
			Node cellChildNode = cellChildNodes.item(0);
			if ((cellChildNode.getNodeType() == Node.ELEMENT_NODE)) {
				String nodeName = cellChildNode.getNodeName();
				if (containsSPB(cellChildNode)){
					if (nodeName.equals(TEXT_SOFT_PAGE_BREAK)){
						// remove inner soft page break node
						cellNode.removeChild(cellChildNode);
					} else if (nodeName.equals(TEXT_H) || nodeName.equals(TEXT_P)) {
						if (factory.split(cellChildNode)){
							cellFirstPart.appendChild(cellChildNode.getPreviousSibling());
							dataMoved=true;
						}
					} else if (nodeName.equals(TEXT_LIST)) {
						if (factory.split(cellChildNode)){
							cellFirstPart.appendChild(cellChildNode.getPreviousSibling());
							dataMoved=true;
					  }
					} else if (nodeName.equals(TABLE_TABLE)) {
						if (factory.split(cellChildNode)){
							cellFirstPart.appendChild(cellChildNode.getPreviousSibling());
							dataMoved=true;
						}
					} else {
						System.out.println("Error. SPB in Cell child node " + nodeName);
						System.exit(1);
					}
						
					break;
				} else {
						cellFirstPart.appendChild(cellChildNode);
						dataMoved = true;
				}
			} else {
				//Append text nodes
				cellFirstPart.appendChild(cellChildNode);
				dataMoved = true;	
			}
			
		}
		if (dataMoved) {
			parent.insertBefore(cellFirstPart, cellNode);
		}
		
		return dataMoved;
	}

}
